<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 41.55 Filter Users</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách người dùng</h2>
        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-md-5 row">
                    <div class="col-md-6 text-center">
                        <label class="form-group mx-2">Trạng thái Order</label>
                    </div>
                    <div class="col-md-6">
                        <select class="form-control" id="sel-status">
                            <option value="all">All</option>
                            <option value="open">Open</option>
                            <option value="confirmed">Confirmed</option>
                            <option value="cancel">Cancel</option>
                        </select>
                    </div>
                </div>
                <div class="col-md-5 row">
                    <div class="col-md-6 text-center">
                        <label class="form-group mx-2">Loại Pizza</label>
                    </div>
                    <div class="col-md-6">
                        <select class="form-control" id="sel-pizza">
                            <option value="all">All</option>
                            <option value="hawaii">Hawaii</option>
                            <option value="bacon">Bacon</option>
                            <option value="seafood">Seafood</option>
                        </select>
                    </div>
                </div>
                <div class="col-md-2 row">
                    <div class="col-md-12 text-right">
                        <button class="btn btn-success" id="btn-filter">Lọc</button>
                    </div>
                </div>
            </div>
        </div>
        <table class="table table-bordered table-hover table-striped" id="table-order">
            <thead>
                <tr>
                    <th>Order Code</th>
                    <th>Kích cỡ Combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước uống</th>
                    <th>Thành tiền </th>
                    <th>Họ và tên </th>
                    <th>Số điện thoại</th>
                    <th>Trạng thái</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>

</body>
<script>
    $(document).ready(function () {
        $("#table-order").on("click", ".btn-detail", function () {
            onBtnClickChiTiet(this);
        });
        $("#btn-filter").on("click", function () {
            onBtnFilterButton(this);
        })

        onPageLoadDing();
    });
    var gDataOrders = []; // khai báo mảng biến toàn cục chứa thông tin đơn hàng 
    const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
    const gCOL_ORDER_CODE = 0;
    const gCOL_KICH_CO = 1;
    const gCOL_LOAI_PIZZA = 2;
    const gCOL_ID_LOAINUOC = 3;
    const gCOL_THANHTIEN = 4;
    const gCOL_HOTEN = 5;
    const gCOL_SODIENTHOAI = 6;
    const gCOL_TRANGTHAI = 7;
    const gCOL_ACTION = 8;
    //
    $("#table-order").DataTable({
        "columns": [
            { "data": gORDER[gCOL_ORDER_CODE] },
            { "data": gORDER[gCOL_KICH_CO] },
            { "data": gORDER[gCOL_LOAI_PIZZA] },
            { "data": gORDER[gCOL_ID_LOAINUOC] },
            { "data": gORDER[gCOL_THANHTIEN] },
            { "data": gORDER[gCOL_HOTEN] },
            { "data": gORDER[gCOL_SODIENTHOAI] },
            { "data": gORDER[gCOL_TRANGTHAI] },
            { "data": gORDER[gCOL_ACTION] },
        ],
        "columnDefs": [
            {
                "targets": gCOL_ACTION,
                "defaultContent": "<button class='btn btn-primary btn-detail'>Chi tiết</button>"
            }
        ]
    })
    function onPageLoadDing() {
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
            data: 'GET',
            dataType: 'json',
            success: function (responseObject) {
                gDataOrders = responseObject;
                console.log(gDataOrders);
                // gọi hàm load đổ dữ liệu vào bảng
                loadDataTable(gDataOrders);
            },
            error: function (error) {
                alert(error.responseText);
            }
        })
    }
    // hàm đổ dữ liệu vào bảng
    function loadDataTable(paramRes) {
        var vUserTable = $("#table-order").DataTable();
        // xoá toàn bộ dữ liệu đang có của bảng
        vUserTable.clear();
        // cập nhập data cho bảng
        vUserTable.rows.add(paramRes);
        // cập nhập lại giao diện hiển thị bảng
        vUserTable.draw();
    }
    // hàm sự kiện nút Button Chi tiết
    function onBtnClickChiTiet(paramButton) {
        var vUserTable = $("#table-order").DataTable();
        // xác định thẻ tr là cha của nút được chọn
        var vRowSelect = $(paramButton).parents('tr');
        // lấy dataRow
        var vDataTableRow = vUserTable.row(vRowSelect);
        // lấy data của dòng
        var vUserData = vDataTableRow.data();
        var vId = vUserData.id;
        var vOrderCode = vUserData.orderCode;
        var vKichCo = vUserData.kichCo;
        var vLoaiPizza = vUserData.loaiPizza;
        var vIdLoaiNuocUong = vUserData.idLoaiNuocUong;
        var vThanhTien = vUserData.thanhTien;
        var vHoTen = vUserData.hoTen;
        var vSoDienThoai = vUserData.soDienThoai;
        var vTrangThai = vUserData.trangThai;
        console.log(vUserData);
        console.log(vId);
    }
    // hàm sự kiện nút Button Lọc
    function onBtnFilterButton() {
        var vStatus = $("#sel-status").val();
        var vPizzaType = $("#sel-pizza").val();
        var vDataFilter = gDataOrders.filter(function (paramOrder) {
            return (vStatus === "all" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase())
                && (vPizzaType === "all" || vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
        });
        loadDataTable(vDataFilter);
    }
</script>

</html>